SystemOrganization addCategory: #ConfigurationOfLog4s!

Object subclass: #ConfigurationOfLog4s
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLog4s'!

!ConfigurationOfLog4s class methodsFor: 'development support' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfLog4s class methodsFor: 'private' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfLog4s class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/1/2014 05:12'!
catalogChangeLog
		
 ^ '- Version 1.0 migrated to SmalltalkHub
[[[
(ConfigurationOfLog4s project version: ''1.0'') load
]]]
'! !

!ConfigurationOfLog4s class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/1/2014 05:15'!
catalogContactInfo

	^ 'Log4s can be discussed in the Pharo-Users mailing list: http://www.pharo-project.org/community

The web home for the Log4s project is : http://ss3.gemstone.com/ss/Log4s.html/Wiki'! !

!ConfigurationOfLog4s class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/1/2014 05:18'!
catalogDescription

	^ 'Log4s is a port to VA Smalltalk of the popular Java logging framework log4s (http://en.wikipedia.org/wiki/Log4j).

Instantiations (http://www.instantiations.com/) is pleased to contribute it to the open source Smalltalk community.

This code has been tested on Pharo 2.0.'! !

!ConfigurationOfLog4s class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/1/2014 05:21'!
catalogKeyClassesAndExample

	^ 'Log4s reads an ini file called log4s.ini on image start to determine what to do.

    Create a file called log4s.ini in the working directory. See Sample Ini File for examples.
    Create a file called startup.sh in the working directory with this contents:

EsLogManager startUp 

There are methods on the class side of EsLogManager in the category sample ini file that you can use to run Log4s. All of these methods start with ''goodRootLoggerIniFile''. They will each run for 75 seconds and will write a log entry every 7 seconds. The values of 75 and 7 can be changed in the method LogManager class>>commonIniFileLines.

You need a listener to run the socket appender examples. See the method LogManager class>>startSocketAppenderServer for details.

See http://www.instantiations.com/docs/852/wwhelp/wwhimpl/js/html/wwhelp.htm#href=sg/log4s.530.1.html#9000401 for details
'! !

!ConfigurationOfLog4s class methodsFor: 'catalog' stamp: 'HernanMoralesDurand 1/1/2014 05:21'!
catalogKeywords
	^ #(log logging log4j log4s)
	! !

!ConfigurationOfLog4s class methodsFor: 'private' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfLog4s class methodsFor: 'private' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfLog4s class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLog4s class methodsFor: 'loading' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfLog4s class methodsFor: 'loading' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfLog4s class methodsFor: 'loading' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfLog4s class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
project

	^self new project! !

!ConfigurationOfLog4s class methodsFor: 'development support' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfLog4s methodsFor: 'baselines' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/Log4s/main'.
		spec package: 'Log4s'.
		spec group: 'default' with: #('Log4s' ). ].
! !

!ConfigurationOfLog4s methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfLog4s methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfLog4s methodsFor: 'accessing' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLog4s methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 1/1/2014 05:05'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfLog4s methodsFor: 'versions' stamp: 'HernanMoralesDurand 1/1/2014 04:47'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '1/1/2014 04:47'.
		spec package: 'Log4s' with: 'Log4s-HernanMoralesDurand.18'. ].
! !
